%define anolis_release 1

%bcond_without tests

%global pypi_name psycopg2
%global desc	Psycopg is the most popular PostgreSQL adapter for the Python \
programming language. At its core it fully implements the Python DB \
API 2.0 specifications. Several extensions allow access to many of the \
features offered by PostgreSQL.

Summary:	Psycopg is the most popular PostgreSQL database adapter for the Python programming language
Name:		python-%{pypi_name}
Version:	2.9.6
Release:	%{anolis_release}%{?dist}
License:	LGPLv3+ with exceptions
Url:		https://pypi.org/project/psycopg2/

Source0:	https://files.pythonhosted.org/packages/af/c4/5726cddb53fe52f0e839eb3da04322364f14493217ebd5818cc5e4c948a5/psycopg2-%{version}.tar.gz

BuildRequires:	python3-devel python3-setuptools
BuildRequires:	gcc
BuildRequires:	libpq-devel
BuildRequires:	python3-sphinx

%if %{with tests}
BuildRequires:	postgresql-test-rpm-macros
%endif

Conflicts:	python-psycopg2-zope < %{version}

%description
%{desc}


%package -n python3-psycopg2
Summary: Psycopg is the most popular PostgreSQL database adapter for the Python programming language.

%description  -n python3-psycopg2
%{desc}


%package -n python3-%{pypi_name}-tests
Summary: A testsuite for python3-%{pypi_name}
Requires: python3-%pypi_name = %version-%release

%description -n python3-%{pypi_name}-tests
%desc
This sub-package delivers set of tests for the adapter.


%package -n python3-%{pypi_name}-doc
Summary:  Documentation for psycopg python PostgreSQL database adapter
BuildArch: noarch
Requires: python3-%{pypi_name}

%description -n python3-%{pypi_name}-doc
Documentation and example files for the psycopg python PostgreSQL
database adapter.


%prep
%autosetup -p1 -n psycopg2-%{version}


%build
export CFLAGS=${RPM_OPT_FLAGS} LDFLAGS=${RPM_LD_FLAGS}
python3 setup.py build

for i in `find doc -iname "*.html"`; do sed -i 's/\r//' $i; done
for i in `find doc -iname "*.css"`; do sed -i 's/\r//' $i; done

rm -f doc/html/.buildinfo

sed -i '/better_theme_path/d' doc/src/conf.py
sed -i "/html_theme = 'better'/d" doc/src/conf.py

make html -C doc/src


%check
%if %{with tests}
export PGTESTS_LOCALE=C.UTF-8
%postgresql_tests_run

export PSYCOPG2_TESTDB=${PGTESTS_DATABASES##*:}
export PSYCOPG2_TESTDB_HOST=$PGHOST
export PSYCOPG2_TESTDB_PORT=$PGPORT

cmd="import tests; tests.unittest.main(defaultTest='tests.test_suite')"

PYTHONPATH=%buildroot%python3_sitearch %__python3 -c "$cmd" --verbose
%endif


%install
export CFLAGS=${RPM_OPT_FLAGS} LDFLAGS=${RPM_LD_FLAGS}
python3 setup.py install --no-compile --root %{buildroot}

cp -r tests/ %{buildroot}%{python3_sitearch}/%{pypi_name}/tests/
for i in `find %{buildroot}%{python3_sitearch}/%{pypi_name}/tests/ -iname "*.py"`; do
  sed -i 's|#!/usr/bin/env python|#!/usr/bin/python3|' $i
done

%files -n python3-psycopg2
%license LICENSE
%dir %{python3_sitearch}/psycopg2
%{python3_sitearch}/psycopg2/*.py
%{python3_sitearch}/psycopg2/_psycopg.cpython-%{python3_version_nodots}[!d]*.so
%dir %{python3_sitearch}/psycopg2/__pycache__
%{python3_sitearch}/psycopg2/__pycache__/*.py{c,o}
%{python3_sitearch}/psycopg2-%{version}-py3*.egg-info


%files -n python3-%{pypi_name}-tests
%{python3_sitearch}/psycopg2/tests


%files -n python3-%{pypi_name}-doc
%license LICENSE
%doc doc/src/_build/html
%doc AUTHORS NEWS README.rst

%changelog
* Fri Apr 07 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.9.3-1
- init from upstream
